#
#	Regrese  9. kapitola  Testy
#
rm(list=ls(all=TRUE))
data(Draha)
#
anova(a.ANOVA1<-lm(draha/rychlost~factor(rychlost),data=Draha))
anova(a.lin<-lm(draha/rychlost~rychlost,data=Draha))
anova(a.lin,a.ANOVA1)
#
data(Koreny)
summary(a<-lm(hmotnost~procento+I(procento**2),data=Koreny))
#
attach(Koreny)
bartlett.test(hmotnost,procento)
fligner.test(hmotnost,procento)
#
hmotnost.mean <- hmotnost-tapply(hmotnost,Procento,mean)[Procento]
anova(lm(abs(hmotnost.mean)~Procento))
hmotnost.median <- hmotnost-tapply(hmotnost,Procento,median)[Procento]
anova(lm(abs(hmotnost.median)~Procento))
#
library(car)
library(lmtest)
summary(a<-lm(draha~rychlost+I(rychlost^2),data=Draha))
ncv.test(a)
bptest(a,~fitted(a),studentize=FALSE)
bptest(a,~fitted(a),studentize=TRUE)
#
anova(lm(resid(a)^2~fitted(a)))
#
ncv.test(a,var.formula=~rychlost,data=Draha)
#
shapiro.test(resid(a))
source("dagost.R")
dagostinoTest(resid(a))
#
plot(resid(a)^2~fitted(a))
abline(lm(resid(a)^2~fitted(a)))
#
ncv.test(a,var.formula=~rychlost,data=Draha)
#	jet prkaz, e Koenkerova modifikace souvis s korel. koef.
length(fitted(a))*cor(fitted(a),resid(a)^2)^2
#
u <- resid(lm(hmotnost~Procento,data=Koreny))
qqnorm(u)
qqline(u)
shapiro.test(u)
library(nortest)
ad.test(u)
cvm.test(u)
lillie.test(u)
pearson.test(u,adjust=TRUE)
pearson.test(u,adjust=FALSE)
sf.test(u)
dagostinoTest(u)
#
data(Olymp)
summary(a<-lm(disk~rok,data=Olymp))
#
library(car)
print(dw<-durbin.watson(a,alternative="positive"))
durbin.watson(a,alternative="positive",simulate=FALSE)
#
library(lmtest)
dwtest(a,alternative="greater")
#
print(n <- length(Olymp$rok))
rokStar <- Olymp$rok[-1]-dw$r*Olymp$rok[-n]
diskStar <- Olymp$disk[-1]-dw$r*Olymp$disk[-n]
summary(aStar<-lm(diskStar~rokStar))
print(durbin.watson(aStar,alternative="positive"))
dwtest(aStar,alternative="greater")
#
coef(aStar)[1]/(1-dw$r)
#
plot(disk~rok,data=Olymp)
xx<-seq(min(Olymp$rok),max(Olymp$rok),length=101)
yy<-coef(aStar)[1]/(1-dw$r)+coef(aStar)[2]*xx
lines(yy~xx,lty=2)
lines(predict(a,newdata=list(rok=xx))~xx)
#
plot(resid(a)[-1]~resid(a)[-n])
abline(lm(resid(a)[-1]~resid(a)[-n]))
abline(h=0,lty=4)
##
#############################################################################
##                                                                         ##
##	alternativn een pomoc lme z knihovny nlme                       ##
##                                                                         ##
#############################################################################
library(nlme)
#	piprav nejjednodu monou korelan strukturu
#	autoregrese 1. du, vchoz odhad 0
ar1 <- corAR1()
#	procedura lme() potebuje (aspo formln) tdn do skupin
#	vyrobme jedinou skupinu pro vechna pozorovn
Olymp$Sk <- factor(1)
#	odhad metodou REML
aREML <- lme(disk ~ rok, data=Olymp, random = ~1|Sk,correlation=ar1)
summary(aREML)
#	odhad metodou maximln vrohodnosti
aML <- lme(disk ~ rok, data=Olymp, random = ~1|Sk,correlation=ar1,method="ML")
summary(aML)
#	
#	problm je v tom, e bhem obou svtovch vlek jsou mezery
#
Olymp48 <- Olymp[Olymp$rok>=1948,]
summary(a48<-lm(disk~rok,data=Olymp48))
print(dw<-durbin.watson(a48,alternative="positive"))
a48REML <- lme(disk ~ rok, data=Olymp48, random = ~1|Sk,correlation=ar1)
summary(a48REML)
a48ML <- lme(disk ~ rok, data=Olymp48, random = ~1|Sk,correlation=ar1,method="ML")
summary(a48ML)
#
#	jin data: Longley
#
data(longley)
longley$Grp <- factor(1)
summary(a <- lm(Unemployed~GNP+Population,data=longley))
durbin.watson(a)
ar1 <- corAR1()
aREML <- lme(Unemployed~GNP+Population,data=longley,random=~1|Grp,corr=ar1)
summary(aREML)
aML <- lme(Unemployed~GNP+Population,data=longley,random=~1|Grp,corr=ar1,meth="ML")
summary(aML)
#
detach(Koreny)
#
