obr14.2 <- function(soubor="../obr14_2.ps",x1=1,x2=3,theta=seq(0,1,length=101)){
#	kresl dvojici obrzk
beta <- exp(theta)
## psGraf(soubor)
opar <- par(mfrow = c(1,2), oma = c(1.1, 0, 1.1, 0), las = 1,cex.lab=1.5)
#	obrzek pro theta
plot(fceT0(theta,x1=x1,x2=x2),main=expression(theta),type="l")

#	obrzek pro beta
plot(fceB0(beta,x1=x1,x2=x2),main=expression(beta),type="l")

#	ukonen
par(opar)
## dev.off()
}
#
#	pomocn funkce
#
#	regrese, kapitola Parametrizace v NLR
fceT0 <- function(theta,x1=1,x2=3){
#       vektor funkcnich hodnot f(theta)
OUT <- NULL
for (i in 1:length(theta)) 
        OUT <- rbind(OUT,c(exp(x1*theta[i]),exp(x2*theta[i])))
OUT
}
fceT1 <- function(theta,x1=1,x2=3){
#       vektor prvnich derivaci f(theta)
OUT <- NULL
for (i in 1:length(theta)) 
        OUT <- rbind(OUT,c(x1*exp(x1*theta[i]),x2*exp(x2*theta[i])))
OUT
}
fceT2 <- function(theta,x1=1,x2=3){
#       vektor druhych derivaci f(theta)
OUT <- NULL
for (i in 1:length(theta)) 
        OUT <- rbind(OUT,c(x1^2*exp(x1*theta[i]),x2^2*exp(x2*theta[i])))
OUT
}
fceB0 <- function(beta,x1=1,x2=3){
#       vektor funkcnich hodnot f(beta)
OUT <- NULL
for (i in 1:length(beta)) 
        OUT <- rbind(OUT,c(beta[i]^x1,beta[i]^x2))
OUT
}
fceB1 <- function(beta,x1=1,x2=3){
#       vektor prvnich derivaci f(beta)
OUT <- NULL
for (i in 1:length(beta)) 
        OUT <- rbind(OUT,c(x1*beta[i]^(x1-1),x2*beta[i]^(x2-1)))
OUT
}
fceB2 <- function(beta,x1=1,x2=3){
#       vektor druhych derivaci f(beta)
OUT <- NULL
for (i in 1:length(beta)) 
        OUT <- rbind(OUT,c(x1*(x1-1)*beta[i]^(x1-2),x2*(x2-1)*beta[i]^(x2-2)))
OUT
}
fceT2T <- function(theta,x1=1,x2=3){
#       prmt druhch derivac do nadroviny
#       predpoklada skalarni theta
OUT <- c(crossprod(c(fceT1(theta,x1=x1,x2=x2)),c(fceT2(theta,x1=x1,x2=x2))))/
        c(crossprod(c(fceT1(theta,x1=x1,x2=x2))))*fceT1(theta,x1=x1,x2=x2)
OUT
}
fceT2N <- function(theta,x1=1,x2=3){
#       prmt kolm na tecnou nadrovinu
#       predpoklada sklarni theta
OUT <- fceT2(theta,x1=x1,x2=x2)-fceT2T(theta,x1=x1,x2=x2)
OUT
}

fceB2N <- function(beta,x1=1,x2=3){
#       prmt kolm na tecnou nadrovinu
#       predpoklada sklarni theta
OUT <- fceB2(beta,x1=x1,x2=x2)-fceB2T(beta,x1=x1,x2=x2)
OUT
}
fceB2T <- function(beta,x1=1,x2=3){
#       prmt druhch derivac do nadroviny
#       predpoklada skalarni theta
OUT <- c(crossprod(c(fceB1(beta,x1=x1,x2=x2)),c(fceB2(beta,x1=x1,x2=x2))))/
        c(crossprod(c(fceB1(beta,x1=x1,x2=x2))))*fceB1(beta,x1=x1,x2=x2)
OUT
}

