piMulticol <- function(#
#
#	diagnostika vlivu jedn. regresor na multikolinearitu
#	pi-koeficienty
#
model,		#	lm s abs. lenem
center = TRUE,	#	zda model centrovat
scale = TRUE)	#	zda model klovat
{
#	ov existenci abs. lenu
if(attr(model$terms,"intercept")!=1) stop("Intercept?")
#	sestav matici modelu
X <- model.matrix(model)
#	je pln sloupcov hodnost?
if(model$rank<ncol(X)) stop("Rank!")
#	je teba centrovat?
if (center) X <- apply(X,2,function(x) x-mean(x))[,-1]
#	je teba klovat na jedn. dlku?
if (scale) X <- apply(X,2,function(x) x/sqrt(crossprod(x)))
#	najdi SVD rozklad
svd <- svd(X)
V <- svd$v
d <- svd$d
#	kappa koeficient
P <- V^2 %*% diag(1/d^2)
piMce <- diag(1/apply(P,1,sum)) %*% P
rownames(piMce) <- colnames(X)
OUT <- rbind(lambda=d^2,eta=(d[1]/d)^2,piMce)
return(OUT)
}
