#	regrese - 13. kapitola (Nelinern regrese)
rm(list=ls(all=TRUE))
#	graf obr. 14.1
source("psGraf.R")
fceMM <- function(x,theta1=2,theta2=0.5) theta1*x/(theta2+x)
#	pro kreslen regresn nadplochy jako fce theta2
x1 <- 0.1; x2 <- 10
t1 <- 2; t21 <- 0.1; t22 <- 0.4; t23 <- 0.7
t2 <- seq(0.09,1,length=101)
y1 <- fceMM(x1,t1,t2)
y2 <- fceMM(x2,t1,t2)
t1a <- 1.9
y1a <- fceMM(x1,t1a,t2)
y2a <- fceMM(x2,t1a,t2)
xlim <- range(c(y1,y1a)); ylim <- range(c(y2,y2a))
psGraf("../MichMent1.ps")
plot(y1,y2,type="l",main="",xlim=xlim,ylim=ylim,
	xlab=expression(y[1]),ylab=expression(y[2]))
points(fceMM(x1,t1,t21),fceMM(x2,t1,t21),pch="+",cex=2)
points(fceMM(x1,t1,t22),fceMM(x2,t1,t22),pch="+",cex=2)
points(fceMM(x1,t1,t23),fceMM(x2,t1,t23),pch="+",cex=2)
#	jin hodnota t1
lines(y1a,y2a,lty=2)
points(fceMM(x1,t1a,t21),fceMM(x2,t1a,t21),pch="+",cex=2)
points(fceMM(x1,t1a,t22),fceMM(x2,t1a,t22),pch="+",cex=2)
points(fceMM(x1,t1a,t23),fceMM(x2,t1a,t23),pch="+",cex=2)
legend("bottomright",
	legend=c(expression(theta[1]==2),
	expression(theta[1]=="1,9")),
	lty=1:2)
dev.off()
#
#	pklad 14.1
#
data(Kan)
attach(Kan)
bcKan <- nls(y~(x+(625-x)*(1-exp(-b*x/(625-x))))/c,start=list(b=5,c=10))
summary(bcKan)
plot(profile(bcKan,1,alphamax=0.02))
plot(profile(bcKan,2,alphamax=0.02))
#	prbh
psGraf("../Kan0.ps")
plot(y~x)
xx <- seq(min(x),max(x),length=101)
yy <- predict(bcKan,newdata=list(x=xx))
lines(yy~xx)
#	podmodel
summary(cKan <- nls(y~x/c,start=list(c=1)))
anova(cKan,bcKan)
yyp <- predict(cKan,newdata=list(x=xx))
lines(yyp~xx,lty=2)
legend("bottomright",legend=c("model","podmodel"),lty=c(1,2))
dev.off()
#	profily
psGraf("../KanBC.ps")
opar <- par(mfrow = c(1,2), oma = c(1.1, 0, 1.1, 0), las = 1,cex.lab=1.5)
plot(profile(bcKan,1,alphamax=0.02),ylab=paste("|",expression(tau),"|",sep=""))
plot(profile(bcKan,2,alphamax=0.02),ylab=paste("|",expression(tau),"|",sep=""),)
par(opar)
dev.off()
#	"pvodn" parametrizace
bdKan <- nls(y~(x+(625-x)*(1-exp(-b*x/(625-x))))*d,start=list(b=5,d=.1))
psGraf("../KanBD.ps")
opar <- par(mfrow = c(1,2), oma = c(1.1, 0, 1.1, 0), las = 1,cex.lab=1.5)
plot(profile(bdKan,1,alphamax=0.02),ylab=paste("|",expression(tau),"|",sep=""))
plot(profile(bdKan,2,alphamax=0.02),ylab=paste("|",expression(tau),"|",sep=""))
par(opar)
dev.off()
#
#	varianta t graf vedle sebe
#
source("plotProfileKZv.R")
library(ellipse)
psGraf("../KanBCD.ps",width=6.35,height=3.35)
opar <- par(mfrow = c(1,3), oma = c(1.1, 0, 1.1, 0), las = 1,cex.lab=1.5)
plot(profile(bcKan,1,alphamax=0.02),xlab=expression(beta))
plot(profile(bcKan,2,alphamax=0.02),xlab=expression(gamma))
plot(profile(bdKan,2,alphamax=0.02),xlab=expression(delta))
dev.off()
#	jet dv dvojice konfidennch mnoin
fceBC <- function(x,b,c) (x+(625-x)*(1-exp(-b*x/(625-x))))/c
fceBD <- function(x,b,d) (x+(625-x)*(1-exp(-b*x/(625-x))))*d
SfceBC <- function(b,c) crossprod(y-fceBC(x,b,c)[1:length(x)])
SfceBD <- function(b,d) crossprod(y-fceBD(x,b,d)[1:length(x)])
N <- 101; minD <- .15; maxD <- .45
bd <- bc <- matrix(NA,N,N)
bb <- seq(0,5,length=N)
cc <- seq(1/maxD,1/minD,length=N)
dd <- seq(minD,maxD,length=N)
for (i in 1:N) for (j in 1:N) bc[i,j] <- SfceBC(bb[i],cc[j])
for (i in 1:N) for (j in 1:N) bd[i,j] <- SfceBD(bb[i],dd[j])
psGraf("../konfMnozBCD.ps")
opar <- par(mfrow = c(1,2), oma = c(1.1, 0, 1.1, 0), las = 1,cex.lab=1.5)
contour(bb,cc,bc,levels=deviance(bcKan)*(1+2/30*qf(.95,2,30)),
	drawlabels=FALSE,lty=1,xlab=expression(beta),ylab=expression(gamma))
points(coef(bcKan)[1],coef(bcKan)[2],pch="+")
lines(ellipse(bcKan),lty=2)
contour(bb,dd,bd,levels=deviance(bdKan)*(1+2/30*qf(.95,2,30)),
	drawlabels=FALSE,lty=1,xlab=expression(beta),ylab=expression(delta))
points(coef(bdKan)[1],coef(bdKan)[2],pch="+")
lines(ellipse(bdKan),lty=2)
dev.off()
#
#	puromycin
#
data(Puromycin)
#	data jsou soust erka
attach(Puromycin)
purT<-nls(rate~Vm*conc/(K+conc),sub=state=="treated",st=c(Vm=200,K=1))
summary(purT)
purUn<-nls(rate~Vm*conc/(K+conc),sub=state=="untreated",st=c(Vm=200,K=1))
summary(purUn)
#
#	Grafick znzornn prbhu
psGraf("../Puro1.ps")
plot(rate~conc,pch=16+(state=="treated"))
xx<-seq(0,1.1,length=101)
lines(xx,predict(purT,data.frame(conc=xx)),lty=2)
lines(xx,predict(purUn,data.frame(conc=xx)),lty=4)
legend("bottomright",leg=c("treated","untreated"),pch=c(17,16),lty=c(2,4))
dev.off()
#	
library(ellipse)
xx<-seq(140,240,length=41)
yy<-seq(0.025,0.1,length=41)
zz<-matrix(NA,41,41)
#
psGraf("../Puro2.ps")
S<-function(x,y,Vm,K) crossprod(y-(Vm*x)/(K+x))
for (i in 1:41) for (j in 1:41) zz[i,j]<-S(conc[state=="treated"],rate[state=="treated"],xx[i],yy[j])
contour(xx,yy,zz,levels=deviance(purTrt)*(1+2/10*qf(.95,2,10)),col="red",add=FALSE,drawlabels=FALSE,
	xlab=expression(theta[1]),ylab=expression(theta[2]))
points(coef(purTrt)[1],coef(purTrt)[2],pch="+",cex=2,col="red")
lines(ellipse(purTrt),lty=2,col="red")
for (i in 1:41) for (j in 1:41) zz[i,j]<-S(conc[state=="untreated"],rate[state=="untreated"],xx[i],yy[j])
contour(xx,yy,zz,levels=deviance(purUntrt)*(1+2/9*qf(.95,2,9)),col="blue",add=TRUE,drawlabels=FALSE)
points(coef(purUntrt)[1],coef(purUntrt)[2],pch="+",cex=2,col="blue")
lines(ellipse(purUntrt),lty=2,col="blue")
dev.off()
#	oboj parametry individuln
pur4<-nls(rate~(Vm+dVm*(state=="untreated"))*conc/((K+dK*(state=="untreated"))+conc),start=c(Vm=200,K=1,dVm=10,dK=0.05))
summary(pur4)
#	individuln jen horn limita, "poloas" stejn
pur3<-nls(rate~(Vm+dVm*(state=="untreated"))*conc/(K+conc),start=c(Vm=200,K=1,dVm=10))
summary(pur3)
#	porovnn
#
#	piblin testy pomrem vrohodnosti 
#	(piblin kvli neznmmu sigma)
anova(pur3,pur4)
#
#	logaritmick vrohodnostn funkce
1-pchisq(2*c(logLik(pur4)-logLik(pur3)),1)
#
#	asymptotick normalita, porovnn dvou nezvislch odhad
print(sTrt<-summary(purT)$coef)
print(sUntrt<-summary(purUn)$coef)
print(Z<-(sTrt[2,1]-sUntrt[2,1])/sqrt(sTrt[2,2]^2+sUntrt[2,2]^2))
2*(1-pnorm(abs(Z)))
